{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 3.0 for Delphi 3 or newer                   ::
  ::                                                         ::
  :: Demo to show how to print a range of pages for reports  ::
  :: that have stretching controls on them                   ::
  ::                                                         ::
  :: Copyright (c) 1999 QuSoft AS                            ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.no   fax: +47 22 41 74 91        ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    Memo1: TMemo;
    btnRegular: TButton;
    btnReport: TButton;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    procedure btnRegularClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses rpt1;

{$R *.DFM}

procedure TfrmMain.btnRegularClick(Sender: TObject);
begin
  btnRegular.Enabled := false;
  with TfrmRpt1.Create(Application) do
  begin
    QuickRep1.Preview;
    Free;
  end;
  btnRegular.Enabled := true;
end;

procedure TfrmMain.btnReportClick(Sender: TObject);
var
  s: string;
begin
  btnReport.Enabled := false;
  s := btnReport.Caption;
  btnReport.Caption := 'Busy...';
  with TfrmRpt1.Create(Application) do
  begin
    with QuickRep1 do
    begin
      // First pass of report to get the stretched height of a band
      btnReport.Caption := 'Pass one...';
      CheckDelta := True;
      Prepare;

      // After you are done with prepare, you must manually free the
      // QRPrinter and set it to nil.
      QRPrinter.Free;
      QRPrinter := nil;

      // Second & final pass
      btnReport.Caption := 'Pass two...';
      CheckDelta := False;
      Preview;
    end;
  end;
  btnReport.Enabled := true;
  btnReport.Caption := s;
end;

end.
